<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class LocalFactory {
    use TQuery;
    
    protected $connection;
    protected $entityManager;
    protected $alias;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
        $this->alias = "fcLocal";
    }
    
    public function getLocals() {
        $sqlCode = "SELECT NRLOCALCLIENTE, NMLOCALCLIENTE, NRCHECKLISTPADR, NRTIPOLOCALCLI
                      FROM FCM_LOCALCLI";
        $std = $this->connection->prepare($sqlCode);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getLocalsDatasource() {
        $sql = "SELECT NRLOCALCLIENTE, NMLOCALCLIENTE, NRCHECKLISTPADR, NRTIPOLOCALCLI
                      FROM FCM_LOCALCLI";
                      
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

   public function selectAllLocals($params) {
       $useParams = false;
       
        $sqlCode = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE,
                       FCM_LOCALCLI.NRSETOR, FCM_LOCALCLI.NRLOCALCLIENTEPAI,
                       FCM_TIPOLOCALCLI.NRTIPOLOCALCLI, FCM_LOCALCLI.DSCORIDLOCAL
                    FROM FCM_LOCALCLI
                        JOIN FCM_TIPOLOCALCLI
                            ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI";
        
        $whereClausule = $this->concatWhereClausule($params);
        if (strlen($whereClausule) > 0) {
            $useParams = true;
            $sqlCode .= $whereClausule;
        }
        $std = $this->connection->prepare($sqlCode);
        if ($useParams) {
            $std->execute($params);   
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }
    
    public function selectLocals($params) {
        $sqlCode = "SELECT NRLOCALCLIENTE, NMLOCALCLIENTE, NRCHECKLISTPADR
                      FROM FCM_LOCALCLI
                     WHERE NRTIPOLOCALCLI in (".$params["nr"].")";
        $std = $this->connection->prepare($sqlCode);
        $std->execute();
        return $std->fetchAll();
    }
    
    private function concatWhereClausule($params) {
        $useParams = false;
        $paramKeys = array_keys($params);
        $query = "";
        foreach($paramKeys as $key) {
            if (!$useParams) {
                $useParams = true;
                $query.= " WHERE ";
            } else {
                $query.= " AND ";
            }
            $query.= 'FCM_LOCALCLI' . "." . $key . " = :" . $key;
        }
        return $query;
    }
}
?>