<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class PrioridadeManutFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function inserirPrioridade($parametros) {

        $sql = "INSERT INTO FCM_PRIORIDADEMANUT(NRPRIORIDADEMANUT, NMPRIORIDADEMANUT, DSCORPRIORIDADE, DTINCLUSAO)
                VALUES (:NRPRIORIDADEMANUT, :NMPRIORIDADEMANUT, :DSCORPRIORIDADE, SYSDATE)";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);

    }

    public function getInformacoesPrioridades() {

        $sql = "SELECT P.NRPRIORIDADEMANUT, P.NMPRIORIDADEMANUT, P.DSCORPRIORIDADE, I.NMIMPACTOMANUT,
                    (SELECT LISTAGG(FCM_IMPACTOMANUT.NMIMPACTOMANUT, ', ') WITHIN GROUP (ORDER BY FCM_RELPRIORIDADEIMPACTO.NRIMPACTOMANUT)
                            FROM FCM_RELPRIORIDADEIMPACTO
                            JOIN FCM_IMPACTOMANUT
                              ON FCM_RELPRIORIDADEIMPACTO.NRIMPACTOMANUT = FCM_IMPACTOMANUT.NRIMPACTOMANUT
                           WHERE P.NRPRIORIDADEMANUT = FCM_RELPRIORIDADEIMPACTO.NRPRIORIDADEMANUT) NMIMPACTOPADRAOPRIORIDADE
                        FROM FCM_PRIORIDADEMANUT P
                        LEFT JOIN FCM_IMPACTOMANUT I
                          ON I.NRPRIORIDADEMANUTPADR = P. NRPRIORIDADEMANUT
                    ORDER BY P.NRPRIORIDADEMANUT";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();

    }

    public function inserirImpactoRelacionado($parametros) {

        $sql = "INSERT INTO FCM_RELPRIORIDADEIMPACTO(RELPRIORIDADEIMPACTO, NRPRIORIDADEMANUT, NRIMPACTOMANUT, DTINCLUSAO)
                    VALUES(:RELPRIORIDADEIMPACTO, :NRPRIORIDADEMANUT, :NRIMPACTOMANUT, SYSDATE)";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }
}

?>