/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PLAN                                                     */
/* Tabela : PARAMPLANEJA                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 05/07/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PLAN
BEFORE INSERT OR UPDATE OR DELETE
ON PARAMPLANEJA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPLAN := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.IDREQUSERV,  '') <> NVL(:NEW.IDREQUSERV,  '')) OR
         (NVL(:OLD.IDREQUANAL,  '') <> NVL(:NEW.IDREQUANAL,  '')) OR
         (NVL(:OLD.IDREQUSETO,  '') <> NVL(:NEW.IDREQUSETO,  '')) OR
         (NVL(:OLD.IDREQUEXTR,  '') <> NVL(:NEW.IDREQUEXTR,  '')) OR
         (NVL(:OLD.IDREQUGERAL, '') <> NVL(:NEW.IDREQUGERAL, '')) OR
         (NVL(:OLD.IDPERCCOME,  '') <> NVL(:NEW.IDPERCCOME,  '')) OR
         (NVL(:OLD.IDUTILFATCOR,'') <> NVL(:NEW.IDUTILFATCOR,'')) OR
         (NVL(:OLD.IDUTILFATCOC,'') <> NVL(:NEW.IDUTILFATCOC,'')) OR
         (NVL(:OLD.IDTIPCALCFAT,'') <> NVL(:NEW.IDTIPCALCFAT,'')) OR
         (NVL(:OLD.NRCORSAFRA,    0) <> NVL(:NEW.NRCORSAFRA,    0)) OR
         (NVL(:OLD.NRCORINICSAF,  0) <> NVL(:NEW.NRCORINICSAF,  0)) OR
         (NVL(:OLD.NRCORENTRSAF,  0) <> NVL(:NEW.NRCORENTRSAF,  0)) OR
         (NVL(:OLD.TXMENSCARMES,'') <> NVL(:NEW.TXMENSCARMES,'')) OR
         (NVL(:OLD.IDCARDIAUTIL,'') <> NVL(:NEW.IDCARDIAUTIL,'')) OR
         (NVL(:OLD.CDNUTRRELAT1,'') <> NVL(:NEW.CDNUTRRELAT1,'')) OR
         (NVL(:OLD.CDNUTRRELAT2,'') <> NVL(:NEW.CDNUTRRELAT2,'')) THEN
         :NEW.DTULTATUPLAN := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PARAMPLANEJA', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDPARPLANEJA='||:OLD.CDPARPLANEJA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PARAMPLANEJA MODIFY DTULTATUPLAN DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PLAN','4.05.052'); END;
/

