create or replace TRIGGER TRILHAUDIT_RECURSOANA
BEFORE INSERT OR UPDATE OR DELETE
ON RECURSOANA FOR EACH ROW
DECLARE
   V_NRSEQTRILHA  NUMBER(10);
   V_NMPRODUTO    VARCHAR2(50);
   V_ITEMALTERADO VARCHAR2(1000);
   V_NEWTIPOINSU  VARCHAR2(50);
   V_NMRECURSO    VARCHAR2(50);
   V_OLDTIPOINSU  VARCHAR2(50);
   V_CDOPERADOR   VARCHAR2(12);
   V_CLIENT_INFO  VARCHAR2(64);
   V_CDARVINSPEC  VARCHAR2(50);
   V_MAXNVINSPEC  NUMBER;
   V_NMANALISE    VARCHAR2(50);
   V_NMINSPECAO   VARCHAR2(200);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_ITEMALTERADO := '';
   V_CDARVINSPEC  := '';
   V_NMANALISE    := '';

   --NMUSUARIO(V_NMOPERADOR);
   --DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
   --V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,45,12);

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   V_CDOPERADOR := V_DSREMOTEOPER;
   --RAISE_APPLICATION_ERROR(-20405,V_NMOPERADOR||'***'||V_CDOPERADOR||'***'||V_DSREMOTEOPER, TRUE);

   IF INSERTING THEN
      V_ITEMALTERADO :=  'Insero de Recurso';
      BEGIN
         SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
           INTO V_NRSEQTRILHA
           FROM TRILHAUDIT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NRSEQTRILHA := 0;
      END;
      
      IF (:NEW.IDTPRECURSO = 'E') THEN
         BEGIN
            SELECT NMEQUIPPRO
              INTO V_NMRECURSO
              FROM EQUIPAPROD
             WHERE CDEQUIPPRO = :NEW.CDEQUIPPRO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMRECURSO := '';
         END;
      ELSIF (:NEW.IDTPRECURSO = 'H') THEN
         BEGIN
            SELECT NMHABILIDADE
              INTO V_NMRECURSO
              FROM HABILIDADE
             WHERE CDHABILIDADE = :NEW.CDHABILIDADE;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMRECURSO := '';
         END;
      END IF;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMINSPECAO
           FROM INSPECAO
          WHERE CDINSPECAO = :NEW.CDINSPECAO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMINSPECAO := NULL;
      END;

      BEGIN
         SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
           INTO V_CDARVINSPEC, V_MAXNVINSPEC
           FROM INSPECAO
          WHERE IDORIGINSPEC IN 'ANA'
            AND CDINSPECAO = :NEW.CDINSPECAO
          GROUP BY CDARVINSPEC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_CDARVINSPEC := NULL;
         V_MAXNVINSPEC := NULL;
      END;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMANALISE
           FROM INSPECAO
          WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
            AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMANALISE := NULL;
      END;

      V_ITEMALTERADO :=  'Insero do Recurso ' || V_NMRECURSO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

      INSERT INTO TRILHAUDIT
         (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
      VALUES
         (V_NRSEQTRILHA, :NEW.CDPRODUTO, :NEW.IDPROCPROD, 'I', SYSDATE, NULL, 'Insero do Recurso ' || V_NMRECURSO, V_CDOPERADOR, V_ITEMALTERADO);

   ELSIF DELETING THEN
      BEGIN
         SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
           INTO V_NRSEQTRILHA
           FROM TRILHAUDIT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NRSEQTRILHA := 0;
      END;

      IF (:OLD.IDTPRECURSO = 'E') THEN
         BEGIN
            SELECT NMEQUIPPRO
              INTO V_NMRECURSO
              FROM EQUIPAPROD
             WHERE CDEQUIPPRO = :OLD.CDEQUIPPRO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMRECURSO := '';
         END;
      ELSIF (:OLD.IDTPRECURSO = 'H') THEN
         BEGIN
            SELECT NMHABILIDADE
              INTO V_NMRECURSO
              FROM HABILIDADE
             WHERE CDHABILIDADE = :OLD.CDHABILIDADE;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMRECURSO := '';
         END;
      END IF;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMINSPECAO
           FROM INSPECAO
          WHERE CDINSPECAO = :NEW.CDINSPECAO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMINSPECAO := NULL;
      END;

      BEGIN
         SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
           INTO V_CDARVINSPEC, V_MAXNVINSPEC
           FROM INSPECAO
          WHERE IDORIGINSPEC IN 'ANA'
            AND CDINSPECAO = :NEW.CDINSPECAO
          GROUP BY CDARVINSPEC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_CDARVINSPEC := NULL;
         V_MAXNVINSPEC := NULL;
      END;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMANALISE
           FROM INSPECAO
          WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
            AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NMANALISE := NULL;
      END;

      V_ITEMALTERADO :=  'Excluso de Recurso ' || V_NMRECURSO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

      INSERT INTO TRILHAUDIT
         (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
      VALUES
         (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'E', SYSDATE, NULL, 'Excluso do Recurso ' || V_NMRECURSO, V_CDOPERADOR, V_ITEMALTERADO);
   ELSIF UPDATING THEN
      IF (:NEW.IDTPRECURSO = 'E') THEN
         BEGIN
            SELECT NMEQUIPPRO
              INTO V_NMRECURSO
              FROM EQUIPAPROD
             WHERE CDEQUIPPRO = :NEW.CDEQUIPPRO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMRECURSO := '';
         END;
      ELSIF (:NEW.IDTPRECURSO = 'H') THEN
         BEGIN
            SELECT NMHABILIDADE
              INTO V_NMRECURSO
              FROM HABILIDADE
             WHERE CDHABILIDADE = :NEW.CDHABILIDADE;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMRECURSO := '';
         END;
      END IF;

      IF (:NEW.QTRECURANA <> :OLD.QTRECURANA) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Quantidade do Recurso ' || V_NMRECURSO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.QTRECURANA, :NEW.QTRECURANA, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.QTHORARECURANA <> :OLD.QTHORARECURANA) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         BEGIN
            SELECT CDARVINSPEC, MAX(CDNVINSPECAO)
              INTO V_CDARVINSPEC, V_MAXNVINSPEC
              FROM INSPECAO
             WHERE IDORIGINSPEC IN 'ANA'
               AND CDINSPECAO = :NEW.CDINSPECAO
             GROUP BY CDARVINSPEC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_CDARVINSPEC := NULL;
            V_MAXNVINSPEC := NULL;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMANALISE
              FROM INSPECAO
             WHERE CDNVINSPECAO = V_MAXNVINSPEC - 1
               AND CDARVINSPEC LIKE SUBSTR(V_CDARVINSPEC, 1, V_MAXNVINSPEC);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NMANALISE := NULL;
         END;

         V_ITEMALTERADO :=  'Quantidade Horas do Recurso ' || V_NMRECURSO || ' - It. de Anlise ' || V_NMINSPECAO || ' - Anlise ' || V_NMANALISE;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.QTHORARECURANA, :NEW.QTHORARECURANA, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('TRILHAUDIT_RECURSOANA','6.05.xxx'); END;
/